# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def save_file_part(*, file_id: int, file_part: int, bytes: _bytes) -> Request[bool]:
    _buffer = bytearray(b'!\xa6\x04\xb3')
    _buffer += struct.pack('<qi', file_id, file_part)
    serialize_bytes_to(_buffer, bytes)
    return Request(b'' + _buffer)
def get_file(*, precise: bool, cdn_supported: bool, location: abcs.InputFileLocation, offset: int, limit: int) -> Request[abcs.upload.File]:
    _buffer = bytearray(b'\xbe5S\xbe')
    flags = (1 if precise else 0) | (2 if cdn_supported else 0)
    _buffer += struct.pack('<I', flags)
    location._write_boxed_to(_buffer)
    _buffer += struct.pack('<qi', offset, limit)
    return Request(b'' + _buffer)
def save_big_file_part(*, file_id: int, file_part: int, file_total_parts: int, bytes: _bytes) -> Request[bool]:
    _buffer = bytearray(b'=g{\xde')
    _buffer += struct.pack('<qii', file_id, file_part, file_total_parts)
    serialize_bytes_to(_buffer, bytes)
    return Request(b'' + _buffer)
def get_web_file(*, location: abcs.InputWebFileLocation, offset: int, limit: int) -> Request[abcs.upload.WebFile]:
    _buffer = bytearray(b'\x8d\x81\xe6$')
    location._write_boxed_to(_buffer)
    _buffer += struct.pack('<ii', offset, limit)
    return Request(b'' + _buffer)
def get_cdn_file(*, file_token: _bytes, offset: int, limit: int) -> Request[abcs.upload.CdnFile]:
    _buffer = bytearray(b'\xdai_9')
    serialize_bytes_to(_buffer, file_token)
    _buffer += struct.pack('<qi', offset, limit)
    return Request(b'' + _buffer)
def reupload_cdn_file(*, file_token: _bytes, request_token: _bytes) -> Request[Sequence[abcs.FileHash]]:
    _buffer = bytearray(b"\xa8T'\x9b")
    serialize_bytes_to(_buffer, file_token)
    serialize_bytes_to(_buffer, request_token)
    return Request(b'' + _buffer)
def get_cdn_file_hashes(*, file_token: _bytes, offset: int) -> Request[Sequence[abcs.FileHash]]:
    _buffer = bytearray(b'1?\xdc\x91')
    serialize_bytes_to(_buffer, file_token)
    _buffer += struct.pack('<q', offset)
    return Request(b'' + _buffer)
def get_file_hashes(*, location: abcs.InputFileLocation, offset: int) -> Request[Sequence[abcs.FileHash]]:
    _buffer = bytearray(b'*\x98V\x91')
    location._write_boxed_to(_buffer)
    _buffer += struct.pack('<q', offset)
    return Request(b'' + _buffer)
